"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.reverse");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.StyledAppendToBodyOptionsWrapper = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireDefault(require("../../utils/AppPropTypes"));

var _useRefRect = _interopRequireDefault(require("../../hooks/useRefRect/useRefRect"));

var _usePlaceAbove = _interopRequireDefault(require("../../hooks/usePlaceAbove/usePlaceAbove"));

var _Wrapper = _interopRequireDefault(require("../Wrapper/Wrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// Only props can by used for styled components, therefore AppendToBodyOptionsWrapper can't use it's state to be styled
var StyledAppendToBodyOptionsWrapper = function StyledAppendToBodyOptionsWrapper(props, ref) {
  var className = props.className,
      children = props.children,
      placeOptionsAbove = props.placeOptionsAbove,
      parentRect = props.parentRect,
      otherProps = _objectWithoutProperties(props, ["className", "children", "placeOptionsAbove", "parentRect"]);

  return _react.default.createElement(_Wrapper.default, _extends({
    className: className,
    ref: ref
  }, otherProps), children);
};

exports.StyledAppendToBodyOptionsWrapper = StyledAppendToBodyOptionsWrapper;
exports.StyledAppendToBodyOptionsWrapper = StyledAppendToBodyOptionsWrapper = (0, _react.forwardRef)(StyledAppendToBodyOptionsWrapper);

var AppendToBodyOptionsWrapper = function AppendToBodyOptionsWrapper(props) {
  var className = props.className,
      children = props.children,
      parentRef = props.parentRef,
      filteredOptions = props.filteredOptions,
      updateOn = props.updateOn,
      StyledAppendToBodyOptionsWrapper = props.StyledAppendToBodyOptionsWrapper,
      otherProps = _objectWithoutProperties(props, ["className", "children", "parentRef", "filteredOptions", "updateOn", "StyledAppendToBodyOptionsWrapper"]);

  var ref = (0, _react.useRef)(null);
  var parentRect = (0, _useRefRect.default)(parentRef, updateOn);
  var optionsWrapperRect = (0, _useRefRect.default)(ref, updateOn);
  var placeOptionsAbove = (0, _usePlaceAbove.default)(parentRect, optionsWrapperRect, updateOn);

  if (placeOptionsAbove && children) {
    filteredOptions = filteredOptions.reverse();
    children = _react.default.cloneElement(children, {
      itemList: filteredOptions
    });
  }

  return _react.default.createElement(StyledAppendToBodyOptionsWrapper, _extends({
    className: className,
    ref: ref,
    placeOptionsAbove: placeOptionsAbove,
    parentRect: parentRect
  }, otherProps), children);
};

AppendToBodyOptionsWrapper.defaultProps = {
  updateOn: []
};
AppendToBodyOptionsWrapper.propTypes = _objectSpread({
  parentRef: _propTypes.default.object.isRequired,
  filteredOptions: _AppPropTypes.default.itemList.isRequired,
  updateOn: _propTypes.default.array.isRequired,
  StyledAppendToBodyOptionsWrapper: _AppPropTypes.default.element.isRequired
}, _AppPropTypes.default.styles);
var _default = AppendToBodyOptionsWrapper;
exports.default = _default;