"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.includes");

require("core-js/modules/es.array.map");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.string.includes");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireDefault(require("../../utils/AppPropTypes"));

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _withKeys = _interopRequireDefault(require("../../utils/withKeys"));

var _callOnChange = _interopRequireDefault(require("../../utils/callOnChange"));

var _useUpdateSelection = _interopRequireWildcard(require("../../hooks/useUpdateSelection/useUpdateSelection"));

var _styledComponents = require("../styledComponents/styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var CheckRadio = function CheckRadio(rawProps, ref) {
  var props = rawProps.massaged ? rawProps : rawProps.massageDataIn(rawProps);
  var options = props.options;
  (0, _useUpdateSelection.default)(props, true);

  if (!props.multiple && props.options.length === 2 && (0, _useUpdateSelection.allBooleanValues)(props.options)) {
    // Only has boolean values
    options = [props.options.find(function (option) {
      return option.value === 'true';
    })]; // This should be a switch, grab 'true' item
  }

  var type = props.multiple ? 'checkbox' : 'radio';
  var values = props.selection.map(function (item) {
    return item.value;
  });
  var useSwitch = options.length === 1;

  var onChange = function onChange(e) {
    var value = String(e.target.value);
    var method = 'add';
    if (props.multiple || useSwitch) method = e.target.checked ? 'add' : 'remove';

    if ((0, _useUpdateSelection.isBooleanSwitch)(props) && !e.target.checked) {
      value = options[0].value === 'true' ? 'false' : 'true';
      method = 'add';
    } // Don't allow unchecking unless it's removable


    if (props.removable || e.target.checked) (0, _callOnChange.default)(props, value, method);
  };

  var radioUncheck = function radioUncheck(e) {
    if (props.removable && !useSwitch && !props.multiple && props.hasSelection && props.selection[0].value === String(e.target.value)) {
      // Unchecking radio, onChange event won't fire, so we have to use onClick instead
      (0, _callOnChange.default)(props, [], 'replace');
    }
  };

  if (props.disabled) {
    onChange = function onChange() {};
  }

  var Checkable = useSwitch ? props.component_Switch : props.multiple ? props.component_CheckBox : props.component_Radio;
  return _react.default.createElement("div", {
    className: props.className,
    style: props.style,
    ref: ref
  }, options.map(function (option) {
    return _react.default.createElement(Checkable, _extends({
      type: type,
      name: props.name,
      value: option.value,
      disabled: props.disabled,
      onChange: onChange,
      onClick: radioUncheck,
      checked: values.includes(option.value),
      label: option.label,
      title: option.label,
      multiple: props.multiple,
      toggle: useSwitch,
      svg_Checkmark: props.svg_Checkmark
    }, (0, _withKeys.default)(props, 'styles_'), {
      key: option.value
    }));
  }));
};

CheckRadio = (0, _react.forwardRef)(CheckRadio);
CheckRadio.defaultProps = _objectSpread({}, _defaultProps.default, {
  style: {},
  component_CheckBox: _styledComponents.CheckBox,
  component_Radio: _styledComponents.Radio,
  component_Switch: _styledComponents.Switch
});
CheckRadio.propTypes = _objectSpread({
  style: _propTypes.default.object.isRequired,
  disabled: _propTypes.default.bool,
  multiple: _propTypes.default.bool.isRequired,
  selection: _propTypes.default.oneOfType([_propTypes.default.any.isRequired, _propTypes.default.arrayOf(_propTypes.default.any).isRequired, _AppPropTypes.default.itemList.isRequired]).isRequired,
  options: _propTypes.default.oneOfType([_AppPropTypes.default.rawItemList.isRequired, _AppPropTypes.default.itemList.isRequired]).isRequired,
  massageDataIn: _propTypes.default.func.isRequired,
  massaged: _propTypes.default.bool,
  onChange: _propTypes.default.func.isRequired,
  component_CheckBox: _AppPropTypes.default.element.isRequired,
  component_Radio: _AppPropTypes.default.element.isRequired,
  component_Switch: _AppPropTypes.default.element.isRequired,
  svg_Checkmark: _AppPropTypes.default.element.isRequired
}, _AppPropTypes.default.styles);
var _default = CheckRadio;
exports.default = _default;