"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.map");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireDefault(require("../../utils/AppPropTypes"));

var _withKeys = _interopRequireDefault(require("../../utils/withKeys"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var noop = function noop() {};

var preventBlur = function preventBlur(e) {
  return e.preventDefault();
};

var ItemList = function ItemList(props) {
  var styles = (0, _withKeys.default)(props, 'styles_');
  var Item = props.Item;

  var renderItem = function renderItem(item) {
    return _react.default.createElement(Item, _extends({
      item: item,
      removable: props.removable,
      key: item.value || item.label,
      svg_Remove: props.svg_Remove
    }, styles));
  };

  var hasItems = !!props.itemList.length;
  var onClick = hasItems ? props.onClick : noop;
  var onMouseOver = hasItems ? props.onMouseOver : noop;
  var onMouseOut = hasItems ? props.onMouseOut : noop;
  return _react.default.createElement("ul", {
    className: props.className,
    onClick: onClick,
    onMouseDown: preventBlur,
    onTouchStart: preventBlur,
    onMouseOver: onMouseOver,
    onMouseOut: onMouseOut
  }, props.itemList.map(renderItem), !hasItems && props.noItemsText && _react.default.createElement(Item, _extends({
    item: {
      value: '',
      label: props.noItemsText
    },
    removable: false
  }, styles)));
};

ItemList.defaultProps = {
  removable: false
};
ItemList.propTypes = _objectSpread({
  itemList: _AppPropTypes.default.itemList.isRequired,
  removable: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  noItemsText: _propTypes.default.string,
  onMouseOver: _propTypes.default.func,
  onMouseOut: _propTypes.default.func,
  Item: _AppPropTypes.default.element.isRequired,
  svg_Remove: _AppPropTypes.default.element
}, _AppPropTypes.default.styles);
var _default = ItemList;
exports.default = _default;