"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _AppPropTypes = _interopRequireWildcard(require("../../utils/AppPropTypes"));

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _useWindowWidth = _interopRequireDefault(require("../../hooks/useWindowWidth/useWindowWidth"));

var _Select = _interopRequireDefault(require("../Select/Select"));

var _CheckRadio = _interopRequireDefault(require("../CheckRadio/CheckRadio"));

var _styledComponents = require("../styledComponents/styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var hasOverflownX = function hasOverflownX(element) {
  return element.scrollWidth > element.offsetWidth;
};

var NewInput = function NewInput(rawProps) {
  var props = rawProps.massageDataIn(rawProps);
  var canCheckRadio = props.hasOptions <= props.checkRadioMaxCount && !props.creatable && !props.hasOptionGroups;
  var checkRadioRef = (0, _react.useRef)(null);
  var windowWidth = (0, _useWindowWidth.default)();

  var _useState = (0, _react.useState)(canCheckRadio),
      _useState2 = _slicedToArray(_useState, 2),
      isLoading = _useState2[0],
      setIsLoading = _useState2[1]; // Only show CheckRadio after we've loaded


  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isOverflown = _useState4[0],
      setIsOverflown = _useState4[1];

  (0, _react.useEffect)(function () {
    if (canCheckRadio) setIsOverflown(hasOverflownX(checkRadioRef.current, windowWidth));
    if (isLoading) setIsLoading(false);
  }, [props.options, props.creatable, windowWidth, canCheckRadio, isLoading]);
  var hideCheckRadio = isLoading || isOverflown;
  var checkRadioStyle = {
    whiteSpace: 'nowrap',
    overflow: 'visible'
  }; // Make sure we can calculate if CheckRadio has overflown

  if (hideCheckRadio) {
    checkRadioStyle = _objectSpread({}, checkRadioStyle, {
      opacity: 1,
      height: 0,
      overflowY: 'hidden'
    });
  }

  if (!props.hasOptions && !props.creatable) {
    console.error('Select has no options and is not creatable, nothing to display. Consider adding options or making it creatable');
  }

  var CheckRadio = props.component_CheckRadio,
      Select = props.component_Select;
  return [canCheckRadio && _react.default.createElement(CheckRadio, _extends({
    style: checkRadioStyle,
    ref: checkRadioRef
  }, props, {
    massaged: true,
    key: "CheckRadio"
  })), (!canCheckRadio || isOverflown) && _react.default.createElement(Select, _extends({}, props, {
    massaged: true,
    key: "Select"
  }))];
};

NewInput.defaultProps = _objectSpread({}, _defaultProps.default, {
  component_Select: _Select.default,
  component_CheckRadio: _CheckRadio.default,
  component_CheckBox: _styledComponents.CheckBox,
  component_Radio: _styledComponents.Radio,
  component_Switch: _styledComponents.Switch
});
NewInput.propTypes = _objectSpread({}, _AppPropTypes.simpleNewInputPropTypes, {
  component_Select: _AppPropTypes.default.element.isRequired,
  component_CheckRadio: _AppPropTypes.default.element.isRequired,
  component_CheckBox: _AppPropTypes.default.element.isRequired,
  component_Radio: _AppPropTypes.default.element.isRequired,
  component_Switch: _AppPropTypes.default.element.isRequired
});
var _default = NewInput;
exports.default = _default;