"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.includes");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.includes");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _AppPropTypes = require("../../utils/AppPropTypes");

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _essentialLodash = require("../../utils/essentialLodash");

var _reactDom = _interopRequireDefault(require("react-dom"));

var _styledComponents = require("../styledComponents/styledComponents");

var _withKeys = _interopRequireDefault(require("../../utils/withKeys"));

var _callOnChange = _interopRequireDefault(require("../../utils/callOnChange"));

var _useUpdateSelection = _interopRequireDefault(require("../../hooks/useUpdateSelection/useUpdateSelection"));

var _keyCodes = require("../../utils/keyCodes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var targetHasValue = function targetHasValue(e) {
  return e.target.hasAttribute('value') || e.target.hasAttribute('val');
};

var targetValue = function targetValue(e) {
  return String(e.target.value || e.target.getAttribute('val') || '');
};

var Select = function Select(rawProps) {
  var props = rawProps.massaged ? rawProps : rawProps.massageDataIn(rawProps);
  var selfRef = (0, _react.useRef)(null);

  var _useReducer = (0, _react.useReducer)(props.selectReducer, {
    areOptionsOpen: false,
    searchText: '',
    placeholder: props.text_placeholder,
    optionHighlighted: null,
    selectionHighlighted: null,
    width: 0,
    filteredOptions: props.filterOptions(props, '')
  }),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var areOptionsOpen = state.areOptionsOpen,
      searchText = state.searchText,
      placeholder = state.placeholder,
      optionHighlighted = state.optionHighlighted,
      selectionHighlighted = state.selectionHighlighted,
      width = state.width,
      filteredOptions = state.filteredOptions;
  (0, _react.useEffect)(function () {
    dispatch({
      props: props,
      type: 'setWidth',
      payload: selfRef
    });
  }, [areOptionsOpen]);
  (0, _react.useEffect)(function () {
    dispatch({
      props: props,
      type: 'selectionUpdated'
    });
  }, [props.selection]);
  (0, _useUpdateSelection.default)(props); // Update selection based on prop changes

  var styles = _objectSpread({
    styles_width: width,
    styles_multiple: props.multiple,
    styles_disabled: props.disabled,
    styles_hasSelection: props.hasSelection,
    styles_hasOptions: props.hasOptions,
    styles_optionHighlighted: optionHighlighted,
    styles_selectionHighlighted: selectionHighlighted,
    styles_rightToLeft: props.rightToLeft
  }, (0, _withKeys.default)(props, 'styles_'));

  if (!props.hasOptions && !props.creatable) {
    console.error('Select has no options and is not creatable, nothing to display. Consider adding options or making it creatable');
  }

  var selectOption = function selectOption(option) {
    if (!props.multiple) {
      document.activeElement.blur(); // Close options on single select
    }

    (0, _callOnChange.default)(props, option);
  };

  var removeSelectionItem = function removeSelectionItem(selectionItem) {
    if (props.removable) {
      (0, _callOnChange.default)(props, selectionItem, 'remove');
      dispatch({
        props: props,
        type: 'clearSearchText'
      });
    }
  }; // Events


  var onFocus = function onFocus(e) {
    dispatch({
      props: props,
      type: 'openOptions'
    });
    props.onFocus(e);
  };

  var onBlur = function onBlur(e) {
    if (props.singleNoOptions) {
      (0, _callOnChange.default)(props, targetValue(e)); // Make single no options behave like text input
    }

    dispatch({
      props: props,
      type: 'closeOptions'
    });
    props.onBlur(e);
  };

  var onOptionClick = function onOptionClick(e) {
    e.preventDefault();
    if (!targetHasValue(e)) return; // no value, do nothing

    selectOption(targetValue(e));
  };

  var onRemove = function onRemove(e) {
    if (e.target.classList.contains('remove') && targetHasValue(e)) {
      removeSelectionItem(targetValue(e));
    }
  };

  var onHoverOption = function onHoverOption(e) {
    if (targetHasValue(e)) dispatch({
      props: props,
      type: 'setOptionHighlighted',
      payload: targetValue(e)
    });
  };

  var onHoverSelection = function onHoverSelection(e) {
    if (!e.target.classList.contains('remove')) return;
    if (targetHasValue(e)) dispatch({
      props: props,
      type: 'setSelectionHighlighted',
      payload: targetValue(e)
    });
  };

  var onSelectionOut = function onSelectionOut(e) {
    if (!areOptionsOpen) dispatch({
      props: props,
      type: 'clearSelectionHighlighted'
    }); // Stop highlighting selection if mouse leaves select area
  };

  var onKeyDown = function onKeyDown(e) {
    var openKeys = [_keyCodes.ENTER_KEY, _keyCodes.ARROW_UP, _keyCodes.ARROW_DOWN, _keyCodes.ARROW_LEFT, _keyCodes.ARROW_RIGHT, _keyCodes.SPACE, _keyCodes.SEMI_COLON, _keyCodes.EQUAL_SIGN, _keyCodes.COMMA, _keyCodes.DASH, _keyCodes.PERIOD, _keyCodes.FORWARD_SLASH, _keyCodes.OPEN_BRACKET, _keyCodes.BACK_SLASH, _keyCodes.CLOSE_BRAKET, _keyCodes.SINGLE_QUOTE];
    if (!areOptionsOpen && ((0, _essentialLodash.inRange)(e.keyCode, _keyCodes.NUM_LETTER_START, _keyCodes.NUM_LETTER_END) || openKeys.includes(e.keyCode))) dispatch({
      props: props,
      type: 'openOptions'
    }); // if you type letters, numbers, or openKeys then open options

    switch (e.keyCode) {
      case _keyCodes.TAB:
      case _keyCodes.ENTER_KEY:
        if (areOptionsOpen && optionHighlighted != null) {
          dispatch({
            props: props,
            type: 'moveOptionHighlighted',
            payload: 1
          });
          dispatch({
            props: props,
            type: 'clearSearchText'
          });
          selectOption(optionHighlighted);
        }

        break;

      case _keyCodes.ARROW_UP:
        dispatch({
          props: props,
          type: 'moveOptionHighlighted',
          payload: -1
        });
        break;

      case _keyCodes.ARROW_DOWN:
        dispatch({
          props: props,
          type: 'moveOptionHighlighted',
          payload: 1
        });
        break;

      case _keyCodes.ARROW_LEFT:
        dispatch({
          props: props,
          type: 'moveSelectionHighlighted',
          payload: -1
        });
        break;

      case _keyCodes.ARROW_RIGHT:
        dispatch({
          props: props,
          type: 'moveSelectionHighlighted',
          payload: 1
        });
        break;

      case _keyCodes.ESCAPE:
        dispatch({
          props: props,
          type: 'closeOptions'
        });
        break;

      case _keyCodes.BACKSPACE:
      case _keyCodes.DELETE:
        if (!searchText && props.hasSelection) {
          // Only remove if there isn't search text
          var selectionItem = (0, _essentialLodash.last)(props.selection).value;

          if (selectionHighlighted != null) {
            selectionItem = selectionHighlighted;
            dispatch({
              props: props,
              type: 'moveSelectionHighlighted',
              payload: -1
            });
          }

          removeSelectionItem(selectionItem);
        }

        break;

      default:
        break;
    }
  };

  if (props.disabled) {
    onFocus = onBlur = onOptionClick = onKeyDown = onRemove = onHoverOption = function onHoverOption() {};
  }

  var showSelection = props.multiple || !areOptionsOpen; // Multiple: always show. Single: show when options are closed

  var showSearch = props.multiple || areOptionsOpen || !props.hasSelection; // Multiple: always show. Single: show when options are open or when nothing is selected (placeholder should be shown)

  var HtmlFieldData = props.component_HtmlFieldData,
      Wrapper = props.component_Wrapper,
      Selection = props.component_Selection,
      SelectionList = props.component_SelectionList,
      OptionList = props.component_OptionList,
      Option = props.component_Option,
      Search = props.component_Search,
      SelectionWrapper = props.component_SelectionWrapper,
      OptionsWrapper = props.component_OptionsWrapper,
      AppendToBodyOptionsWrapper = props.component_AppendToBodyOptionsWrapper,
      StyledAppendToBodyOptionsWrapper = props.component_StyledAppendToBodyOptionsWrapper;

  var optionList = _react.default.createElement(OptionList, _extends({
    itemList: filteredOptions,
    onClick: onOptionClick,
    onMouseOver: onHoverOption,
    Item: Option,
    noItemsText: props.hasOptions ? props.text_noOptions : props.text_create + '...'
  }, styles));

  return (props.hasOptions || props.creatable) && _react.default.createElement(Wrapper, _extends({}, styles, {
    ref: selfRef
  }), props.name && _react.default.createElement(HtmlFieldData, {
    name: props.name,
    itemList: props.selection
  }), _react.default.createElement(SelectionWrapper, _extends({
    onFocus: onFocus,
    onBlur: onBlur,
    svg_Expand: props.svg_Expand
  }, styles, {
    areOptionsOpen: areOptionsOpen,
    SelectionList: showSelection && _react.default.createElement(SelectionList, _extends({
      itemList: props.selection,
      onClick: onRemove,
      onMouseOver: onHoverSelection,
      onMouseOut: onSelectionOut,
      removable: !props.disabled && props.removable,
      svg_Remove: props.svg_Remove,
      Item: Selection
    }, styles)),
    Search: _react.default.createElement(Search, _extends({
      hide: !showSearch,
      placeholder: placeholder,
      searchText: searchText,
      onKeyDown: onKeyDown,
      onChange: function onChange(e) {
        dispatch({
          props: props,
          type: 'clearOptionHighlighted'
        });
        dispatch({
          props: props,
          type: 'setSearchText',
          payload: targetValue(e)
        });
      }
    }, styles))
  })), !props.appendToBody && areOptionsOpen && _react.default.createElement(_styledComponents.DivRelative, null, _react.default.createElement(OptionsWrapper, styles, optionList)), props.appendToBody && areOptionsOpen && _reactDom.default.createPortal(_react.default.createElement(AppendToBodyOptionsWrapper, _extends({}, styles, {
    parentRef: selfRef,
    filteredOptions: filteredOptions,
    StyledAppendToBodyOptionsWrapper: StyledAppendToBodyOptionsWrapper,
    updateOn: [props.selection]
  }), optionList), document.body));
};

Select.defaultProps = _defaultProps.default;
Select.propTypes = _AppPropTypes.simpleDruthersPropTypes;
var _default = Select;
exports.default = _default;