"use strict";

require("core-js/modules/es.object.assign");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _mocks = require("../../mocks");

var _Wrapper = _interopRequireDefault(require("./Wrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

it('adds className', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Wrapper.default, _extends({}, _mocks.mockStyles, {
    className: "test"
  })));
  expect(wrapper.hasClass('test')).toBe(true);
});
it('renders children', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Wrapper.default, _mocks.mockStyles, _react.default.createElement("div", {
    className: "unique"
  })));
  expect(wrapper.contains(_react.default.createElement("div", {
    className: "unique"
  }))).toBe(true);
});
it('pass props', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Wrapper.default, _extends({}, _mocks.mockStyles, {
    otherProp: "otherProp"
  })));
  expect(wrapper.props().otherProp).toBe('otherProp');
});
it('forwards ref', function () {
  var ref = _react.default.createRef();

  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_Wrapper.default, _extends({}, _mocks.mockStyles, {
    ref: ref
  })));
  expect(ref.current).toBeDefined();
});