"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.splice");

require("core-js/modules/es.function.name");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _essentialLodash = require("./essentialLodash");

var internalCallOnChange = function internalCallOnChange(props, value) {
  props.onChange({
    target: {
      value: props.massageDataOut(props, value),
      name: props.name
    }
  });
};

var callOnChange = function callOnChange(props, newValue) {
  var method = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'add';
  // methods: 'add', 'remove', 'replace'
  if (method === 'replace') return internalCallOnChange(props, (0, _essentialLodash.castArray)(newValue));
  var value = method === 'add' ? (0, _essentialLodash.castArray)(newValue) : [];

  if (props.multiple) {
    value = props.selection.map(function (option) {
      return option.value;
    });

    if (method === 'add') {
      var newOption = props.options.find(function (option) {
        return option.value === newValue;
      });

      if (newOption != null && newOption.parent) {
        // Option is a parent, remove selected children
        value = props.selection.filter(function (option) {
          return option.group !== newOption.group;
        }).map(function (option) {
          return option.value;
        });
      }

      value.push(String(newValue)); // Add
    } else {
      value.splice(value.indexOf(String(newValue)), 1); // Remove
    }
  }

  internalCallOnChange(props, value);
};

var _default = callOnChange;
exports.default = _default;