"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _HtmlFieldData = _interopRequireDefault(require("../components/HtmlFieldData/HtmlFieldData"));

var _AppendToBodyOptionsWrapper = _interopRequireDefault(require("../components/AppendToBodyOptionsWrapper/AppendToBodyOptionsWrapper"));

var _styledComponents = require("../components/styledComponents/styledComponents");

var _svg = require("../components/svg/svg");

var _filterOptions = _interopRequireDefault(require("./filterOptions"));

var _massageDataIn = _interopRequireDefault(require("./massageDataIn"));

var _massageDataOut = _interopRequireDefault(require("./massageDataOut"));

var _selectReducer = _interopRequireDefault(require("../reducers/selectReducer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var noop = function noop() {};

var defaultProps = {
  onChange: undefined,
  onBlur: noop,
  onFocus: noop,
  name: undefined,
  selection: [],
  options: [],
  placeholder: 'Select...',
  multiple: false,
  disabled: false,
  creatable: false,
  removable: true,
  appendToBody: false,
  rightToLeft: false,
  allowDuplicates: true,
  alwaysReturnArray: false,
  filterOptions: _filterOptions.default,
  massageDataIn: _massageDataIn.default,
  massageDataOut: _massageDataOut.default,
  selectReducer: _selectReducer.default,
  optionKeys: ['value', 'label'],
  checkRadioMaxCount: 10,
  parseTo: 'string',
  text_placeholder: '',
  text_noOptions: 'No Options',
  text_create: 'Create',
  component_Select: undefined,
  // These undefined ones are defined in Druthers, must be done there or we'd have circular imports
  component_CheckRadio: undefined,
  component_CheckBox: undefined,
  component_Radio: undefined,
  component_Switch: undefined,
  component_HtmlFieldData: _HtmlFieldData.default,
  component_Wrapper: _styledComponents.Wrapper,
  component_Selection: _styledComponents.Selection,
  component_SelectionList: _styledComponents.SelectionList,
  component_OptionList: _styledComponents.OptionList,
  component_Option: _styledComponents.Option,
  component_Search: _styledComponents.Search,
  component_SelectionWrapper: _styledComponents.SelectionWrapper,
  component_OptionsWrapper: _styledComponents.OptionsWrapper,
  component_AppendToBodyOptionsWrapper: _AppendToBodyOptionsWrapper.default,
  component_StyledAppendToBodyOptionsWrapper: _styledComponents.StyledAppendToBodyOptionsWrapper,
  svg_Checkmark: _svg.Checkmark,
  svg_Remove: _svg.Remove,
  svg_Expand: _svg.Expand,
  styles_fontSize: '1em',
  styles_borderRadius: '.2em',
  styles_paddingTop: '.25em',
  styles_paddingBottom: '.25em',
  styles_paddingLeft: '.25em',
  styles_paddingRight: '.25em',
  styles_selection_paddingTop: '.2em',
  styles_selection_paddingBottom: '.2em',
  styles_selection_paddingLeft: '.4em',
  styles_selection_paddingRight: '.4em',
  styles_selection_margin: '.2em',
  styles_option_paddingTop: '.25em',
  styles_option_paddingBottom: '.25em',
  styles_option_paddingLeft: '.25em',
  styles_option_paddingRight: '.25em',
  styles_checkRadio_borderWidth: '2px',
  styles_checkRadio_marginBetween: '1em',
  styles_checkRadio_labelMargin: '.2em',
  styles_checkRadio_paddingTop: '.2em',
  styles_checkRadio_paddingBottom: '.2em',
  styles_checkRadio_paddingLeft: '.2em',
  styles_checkRadio_paddingRight: '.2em',
  styles_search_size: '8',
  styles_icon_width: '1em',
  styles_colors_primary: 'black',
  styles_colors_secondary: '#C3C3C3',
  styles_colors_highlight: 'lightblue',
  styles_colors_warning: '#FABAAC',
  styles_colors_warningBold: '#FA2222',
  styles_colors_disabled: '#ECECEC',
  styles_colors_background: 'white'
};
var _default = defaultProps;
exports.default = _default;