"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _essentialLodash = require("./essentialLodash");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var massageDataIn = function massageDataIn(props) {
  var _ref;

  var selection = props.selection,
      options = props.options,
      placeholder = props.placeholder,
      otherProps = _objectWithoutProperties(props, ["selection", "options", "placeholder"]);

  var isEmpty = selection == null || selection === ''; // Arrayify

  selection = (0, _essentialLodash.castArray)(selection); // Stringify

  selection = selection.map(function (value) {
    return String(value);
  });
  var hasOptionGroups = false;

  var strigifyOption = function strigifyOption(option) {
    return {
      value: String(option[props.optionKeys[0]]),
      label: String(option[props.optionKeys[1]])
    };
  };

  var groupNumber = 1; // Start at 1 because 0 isn't truthy

  options = (_ref = []).concat.apply(_ref, _toConsumableArray(options.map(function (option) {
    // Also flatten option groups
    if (option.options == null) return strigifyOption(option);
    hasOptionGroups = true;
    var newOption = strigifyOption(option);
    var group = groupNumber++;
    if (option.value == null) delete newOption.value;
    return [_objectSpread({}, newOption, {
      group: group,
      parent: true
    })].concat(_toConsumableArray(option.options.map(function (option) {
      return _objectSpread({}, strigifyOption(option), {
        group: group
      });
    })));
  }))); // Objectify selection, turn single value into label/value object

  var massagedSelection = isEmpty ? [] : selection.map(function (value) {
    var option = options.find(function (option) {
      return option.value === value;
    });
    return option == null ? {
      value: value,
      label: value
    } : option;
  }); // Distinct

  if (!props.allowDuplicates) {
    var values = options.map(function (option) {
      return option.value;
    });
    options = options.filter(function (option, index) {
      return values.indexOf(option.value) === index;
    });
  }

  placeholder = props.text_placeholder ? props.text_placeholder : placeholder;
  var hasOptions = !!options.length;
  return _objectSpread({}, otherProps, {
    selection: massagedSelection,
    hasSelection: !!massagedSelection.length,
    options: options,
    hasOptions: hasOptions,
    singleNoOptions: !hasOptions && !props.multiple && props.creatable,
    hasOptionGroups: hasOptionGroups,
    text_placeholder: placeholder
  });
};

var _default = massageDataIn;
exports.default = _default;