"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.includes");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.number.constructor");

require("core-js/modules/es.number.is-nan");

require("core-js/modules/es.parse-float");

require("core-js/modules/es.parse-int");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var emptyValue = function emptyValue(props) {
  switch (props.parseTo.toLowerCase()) {
    case 'number':
    case 'int':
    case 'float':
    case 'boolean':
      return undefined;

    case 'string':
    default:
      return '';
  }
};

var massageDataOut = function massageDataOut(props, onChangeValue) {
  if (!onChangeValue.length) return !props.alwaysReturnArray && !props.multiple ? emptyValue(props) : onChangeValue;

  switch (props.parseTo.toLowerCase()) {
    case 'number':
    case 'int':
      onChangeValue = onChangeValue.slice().map(function (val) {
        return parseInt(val, 10);
      }).filter(function (val) {
        return !Number.isNaN(val);
      });
      break;

    case 'float':
      onChangeValue = onChangeValue.slice().map(function (val) {
        return parseFloat(val);
      }).filter(function (val) {
        return !Number.isNaN(val);
      });
      break;

    case 'boolean':
      onChangeValue = onChangeValue.slice().filter(function (val) {
        return ['true', 'false'].includes(val.toLowerCase());
      }).map(function (val) {
        return val.toLowerCase() === 'true';
      });
      break;

    case 'string':
    default:
      break;
  }

  return !props.alwaysReturnArray && !props.multiple ? onChangeValue[0] : onChangeValue;
};

var _default = massageDataOut;
exports.default = _default;