"use strict";

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.map");

require("core-js/modules/es.object.is");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var decreaseOneAbsolute = function decreaseOneAbsolute(value) {
  if (value === 0) return value;
  return value > 0 ? value - 1 : value + 1;
};

var moveHighlighted = function moveHighlighted(items, distance, highlighted) {
  var defaultLast = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  if (items.length === 0) {
    return undefined;
  }

  var defaultIndex = defaultLast ? items.length - 1 : 0;
  var index = highlighted == null ? defaultIndex + decreaseOneAbsolute(distance) : items.map(function (item) {
    return item.value;
  }).indexOf(highlighted) + distance;
  if (index < 0) index = items.length + index;
  index = index % items.length; // Wrap around

  if (items[index].value == null) {
    // Has no value, continue
    return moveHighlighted(items, distance < 0 || Object.is(distance, -0) // negative 0 or below
    ? distance - 1 : distance + 1, highlighted, defaultLast);
  } else {
    return items[index].value;
  }
};

var _default = moveHighlighted;
exports.default = _default;